﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Configuration;
using System.Net.Http;
using Newtonsoft.Json;

namespace DataAnalysis
{
    public partial class FormMain : Form
    {
        private DateTime now;
        private ToolTip tip;
        private string filePath;
        private string eventPath;
        private long[] OKtotal;
        private SortedList<string, long[]> NGtotal;
        private SortedList<string, long[]> NGtime1st;
        private SortedList<string, long[]> NGtime2nd;
        private SortedList<string, long[]> NGtime3rd;
        private SortedList<string, long[]> NGtime4th;
        private SortedList<string, long[]> NGtime5th;
        private SortedList<string, long[]> NGtime6th;
        private SortedList<string, long[]> NGtime7th;
        private SortedList<string, long[]> NGtime8th;
        private SortedList<string, long[]> NGtime9th;
        private SortedList<string, long[]> NGtime10th;
        private SortedList<string, long[]> NGtime11th;
        private SortedList<string, long[]> NGtime12th;
        private string Host = ConfigurationManager.AppSettings["Host"];
        private string UserID = "VABCDEF";
        private GetUser UserData;
        private string Namer;
        private string District;
        private string Province;
        private string Gender;
        private string Birthday;
        private int ToolTick = -9999;
        private int TimeChange;
        private List<string> ErrorList = new List<string>();

        public FormMain()
        {
            InitializeComponent();
        }

        private async Task<string[]> GetInfo(string key)
        {
            string status;
            string result;
            using (HttpClient client = new HttpClient())
            {
                var message = await client.GetAsync(key);
                status = message.StatusCode.ToString();
                result = await message.Content.ReadAsStringAsync();
            }
            return new string[] { status, result };
        }

        private void UserInfo()
        {
            try
            {
                var t = Task.Run(() => GetInfo(Host + "/shopfloor/employees/?UserId=" + UserID));
                t.Wait();
                if (t.Result[0].Equals("OK") && t.Result[1].Length > 50)
                {
                    UserData = JsonConvert.DeserializeObject<GetUser>(t.Result[1]);
                    string[] names = UserData.results[0].Name.Split(' ');
                    Namer = names[names.Length - 1];
                    string[] address = UserData.results[0].Address.Split('-');
                    District = address[address.Length - 2];
                    Province = address[address.Length - 1];
                    string[] birth = UserData.results[0].Birthday.Split('-');
                    Birthday = birth[1] + "/" + birth[2];
                    if (int.Parse(birth[0]) < 2001)
                    {
                        Gender = UserData.results[0].Gender.Equals("Male") ? "anh " : "chị ";
                    }
                    else
                    {
                        Gender = "";
                    }
                    ToolTick = 0;
                    TimeChange = 0;
                    label5.Text = "Đông chào " + Gender + Namer + " nhá =))";
                }
            }
            catch
            {
                UserInfo();
            }
        }

        private void Logging(string content)
        {
            if (!ErrorList.Contains(content))
            {
                ErrorList.Add(content);
                string[] lines = ErrorList.ToArray();
                File.WriteAllLines("Debug.log", lines);
            }
        }

        private void ChangeText()
        {
            ToolTick++;
            if (TimeChange < 3 && ToolTick / 360 > TimeChange)
            {
                TimeChange++;
                string text = "Xin chào =))";
                switch (TimeChange)
                {
                    case 1:
                        text = "Đất Tổ chào " + Province + " nhá =))";
                        break;
                    case 2:
                        text = District + " mãi đỉnh =))";
                        break;
                    case 3:
                        string day = ((now.Month < 10) ? "0" : "") + now.Month + "/" + ((now.Day < 10) ? "0" : "") + now.Day;
                        if (Birthday.Equals(day))
                        {
                            text = "Mừng thọ " + Gender + Namer + " nhá =))";
                        }
                        else
                        {
                            text = "Vui cười lên =))";
                        }
                        break;
                }
                label5.Text = text;
            }
        }

        private void AddError(int hour, string key, long time)
        {
            int index = 0;
            if (hour < 8)
            {
                hour = 8;
            }
            if (hour > 19)
            {
                hour = 19;
            }
            switch (hour)
            {
                case 8:
                    if (NGtime1st.ContainsKey(key))
                    {
                        index = NGtime1st.IndexOfKey(key);
                        NGtime1st.Values[index][0] += 1;
                        NGtime1st.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime1st.Add(key, new long[] { 1, time });
                    }
                    break;
                case 9:
                    if (NGtime2nd.ContainsKey(key))
                    {
                        index = NGtime2nd.IndexOfKey(key);
                        NGtime2nd.Values[index][0] += 1;
                        NGtime2nd.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime2nd.Add(key, new long[] { 1, time });
                    }
                    break;
                case 10:
                    if (NGtime3rd.ContainsKey(key))
                    {
                        index = NGtime3rd.IndexOfKey(key);
                        NGtime3rd.Values[index][0] += 1;
                        NGtime3rd.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime3rd.Add(key, new long[] { 1, time });
                    }
                    break;
                case 11:
                    if (NGtime4th.ContainsKey(key))
                    {
                        index = NGtime4th.IndexOfKey(key);
                        NGtime4th.Values[index][0] += 1;
                        NGtime4th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime4th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 12:
                    if (NGtime5th.ContainsKey(key))
                    {
                        index = NGtime5th.IndexOfKey(key);
                        NGtime5th.Values[index][0] += 1;
                        NGtime5th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime5th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 13:
                    if (NGtime6th.ContainsKey(key))
                    {
                        index = NGtime6th.IndexOfKey(key);
                        NGtime6th.Values[index][0] += 1;
                        NGtime6th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime6th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 14:
                    if (NGtime7th.ContainsKey(key))
                    {
                        index = NGtime7th.IndexOfKey(key);
                        NGtime7th.Values[index][0] += 1;
                        NGtime7th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime7th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 15:
                    if (NGtime8th.ContainsKey(key))
                    {
                        index = NGtime8th.IndexOfKey(key);
                        NGtime8th.Values[index][0] += 1;
                        NGtime8th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime8th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 16:
                    if (NGtime9th.ContainsKey(key))
                    {
                        index = NGtime9th.IndexOfKey(key);
                        NGtime9th.Values[index][0] += 1;
                        NGtime9th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime9th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 17:
                    if (NGtime10th.ContainsKey(key))
                    {
                        index = NGtime10th.IndexOfKey(key);
                        NGtime10th.Values[index][0] += 1;
                        NGtime10th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime10th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 18:
                    if (NGtime11th.ContainsKey(key))
                    {
                        index = NGtime11th.IndexOfKey(key);
                        NGtime11th.Values[index][0] += 1;
                        NGtime11th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime11th.Add(key, new long[] { 1, time });
                    }
                    break;
                case 19:
                    if (NGtime12th.ContainsKey(key))
                    {
                        index = NGtime12th.IndexOfKey(key);
                        NGtime12th.Values[index][0] += 1;
                        NGtime12th.Values[index][1] += time;
                    }
                    else
                    {
                        NGtime12th.Add(key, new long[] { 1, time });
                    }
                    break;
            }
            if (NGtotal.ContainsKey(key))
            {
                index = NGtotal.IndexOfKey(key);
                NGtotal.Values[index][0] += 1;
                NGtotal.Values[index][1] += time;
            }
            else
            {
                NGtotal.Add(key, new long[] { 1, time });
            }
        }

        private void AddPass(int hour)
        {
            if (hour < 8)
            {
                hour = 8;
            }
            if (hour > 19)
            {
                hour = 19;
            }
            switch (hour)
            {
                case 8:
                    OKtotal[1] += 1;
                    break;
                case 9:
                    OKtotal[2] += 1;
                    break;
                case 10:
                    OKtotal[3] += 1;
                    break;
                case 11:
                    OKtotal[4] += 1;
                    break;
                case 12:
                    OKtotal[5] += 1;
                    break;
                case 13:
                    OKtotal[6] += 1;
                    break;
                case 14:
                    OKtotal[7] += 1;
                    break;
                case 15:
                    OKtotal[8] += 1;
                    break;
                case 16:
                    OKtotal[9] += 1;
                    break;
                case 17:
                    OKtotal[10] += 1;
                    break;
                case 18:
                    OKtotal[11] += 1;
                    break;
                case 19:
                    OKtotal[12] += 1;
                    break;
            }
            OKtotal[0] += 1;
        }

        private void SyncData()
        {
            totalOK.Text = OKtotal[0].ToString();
            OK1st.Text = OKtotal[1].ToString();
            OK2nd.Text = OKtotal[2].ToString();
            OK3rd.Text = OKtotal[3].ToString();
            OK4th.Text = OKtotal[4].ToString();
            OK5th.Text = OKtotal[5].ToString();
            OK6th.Text = OKtotal[6].ToString();
            OK7th.Text = OKtotal[7].ToString();
            OK8th.Text = OKtotal[8].ToString();
            OK9th.Text = OKtotal[9].ToString();
            OK10th.Text = OKtotal[10].ToString();
            OK11th.Text = OKtotal[11].ToString();
            OK12th.Text = OKtotal[12].ToString();
            int i = 0;
            long qty = 0;
            long time = 0;
            long NGqty = 0;
            long NGtime = 0;
            string cap = "\r\n";
            for (i = 0; i < NGtotal.Count; ++i)
            {
                qty = NGtotal.Values[i][0];
                time = NGtotal.Values[i][1];
                cap += "\r\n" + NGtotal.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            totalNG.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(totalNG, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime1st.Count; ++i)
            {
                qty = NGtime1st.Values[i][0];
                time = NGtime1st.Values[i][1];
                cap += "\r\n" + NGtime1st.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG1st.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG1st, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime2nd.Count; ++i)
            {
                qty = NGtime2nd.Values[i][0];
                time = NGtime2nd.Values[i][1];
                cap += "\r\n" + NGtime2nd.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG2nd.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG2nd, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime3rd.Count; ++i)
            {
                qty = NGtime3rd.Values[i][0];
                time = NGtime3rd.Values[i][1];
                cap += "\r\n" + NGtime3rd.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG3rd.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG3rd, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime4th.Count; ++i)
            {
                qty = NGtime4th.Values[i][0];
                time = NGtime4th.Values[i][1];
                cap += "\r\n" + NGtime4th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG4th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG4th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime5th.Count; ++i)
            {
                qty = NGtime5th.Values[i][0];
                time = NGtime5th.Values[i][1];
                cap += "\r\n" + NGtime5th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG5th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG5th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime6th.Count; ++i)
            {
                qty = NGtime6th.Values[i][0];
                time = NGtime6th.Values[i][1];
                cap += "\r\n" + NGtime6th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG6th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG6th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime7th.Count; ++i)
            {
                qty = NGtime7th.Values[i][0];
                time = NGtime7th.Values[i][1];
                cap += "\r\n" + NGtime7th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG7th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG7th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime8th.Count; ++i)
            {
                qty = NGtime8th.Values[i][0];
                time = NGtime8th.Values[i][1];
                cap += "\r\n" + NGtime8th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG8th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG8th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime9th.Count; ++i)
            {
                qty = NGtime9th.Values[i][0];
                time = NGtime9th.Values[i][1];
                cap += "\r\n" + NGtime9th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG9th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG9th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime10th.Count; ++i)
            {
                qty = NGtime10th.Values[i][0];
                time = NGtime10th.Values[i][1];
                cap += "\r\n" + NGtime10th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG10th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG10th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime11th.Count; ++i)
            {
                qty = NGtime11th.Values[i][0];
                time = NGtime11th.Values[i][1];
                cap += "\r\n" + NGtime11th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG11th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG11th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
            qty = 0;
            time = 0;
            NGqty = 0;
            NGtime = 0;
            cap = "\r\n";
            for (i = 0; i < NGtime12th.Count; ++i)
            {
                qty = NGtime12th.Values[i][0];
                time = NGtime12th.Values[i][1];
                cap += "\r\n" + NGtime12th.Keys[i] + " " + qty + " - " + ToTime(time);
                NGqty += qty;
                NGtime += time;
            }
            NG12th.Text = NGqty.ToString();
            if (NGqty > 0)
            {
                tip.SetToolTip(NG12th, "[Tổng] " + NGqty + " - " + ToTime(NGtime) + cap);
            }
        }

        private void Cleanup()
        {
            for (int i = 0; i < 13; ++i)
            {
                OKtotal[i] = 0;
            }
            NGtotal.Clear();
            NGtime1st.Clear();
            NGtime2nd.Clear();
            NGtime3rd.Clear();
            NGtime4th.Clear();
            NGtime5th.Clear();
            NGtime6th.Clear();
            NGtime7th.Clear();
            NGtime8th.Clear();
            NGtime9th.Clear();
            NGtime10th.Clear();
            NGtime11th.Clear();
            NGtime12th.Clear();
        }

        private string ToTime(long time)
        {
            return time < 60 ? time + " giây" : (time < 3600 ? time / 60 + " phút " + (time % 60 == 0 ? "" : time % 60 + " giây") : time / 3600 + " giờ" + (time % 3600 == 0 ? "" : " " + (time % 3600) / 60 + " phút" + ((time % 3600) % 60 == 0 ? "" : " " + (time % 3600) % 60 + " giây")));
        }

        private void FormMain_Load(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
            this.Location = new System.Drawing.Point(Screen.PrimaryScreen.Bounds.Size.Width - this.Width, 0);
            now = DateTime.Now;
            tip = new ToolTip();
            filePath = "C:\\CCM_AutoTest\\log\\CCM." + now.Year + ((now.Month < 10) ? "0" : "") + now.Month + ((now.Day < 10) ? "0" : "") + now.Day + ".log";
            eventPath = "C:\\CCM_AutoTest\\EventsLog\\FFT-log-" + now.Year + ((now.Month < 10) ? "0" : "") + now.Month + ((now.Day < 10) ? "0" : "") + now.Day + ".txt";
            OKtotal = new long[13];
            NGtotal = new SortedList<string, long[]>();
            NGtime1st = new SortedList<string, long[]>();
            NGtime2nd = new SortedList<string, long[]>();
            NGtime3rd = new SortedList<string, long[]>();
            NGtime4th = new SortedList<string, long[]>();
            NGtime5th = new SortedList<string, long[]>();
            NGtime6th = new SortedList<string, long[]>();
            NGtime7th = new SortedList<string, long[]>();
            NGtime8th = new SortedList<string, long[]>();
            NGtime9th = new SortedList<string, long[]>();
            NGtime10th = new SortedList<string, long[]>();
            NGtime11th = new SortedList<string, long[]>();
            NGtime12th = new SortedList<string, long[]>();
            Intializer.Enabled = true;
        }

        private void AutoAnalysis_Tick(object sender, EventArgs e)
        {
            try
            {
                FileStream eventStream = new FileStream(eventPath, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
                StreamReader eventReader = new StreamReader(eventStream);
                string text = "text";
                string userid = "id";
                while (!eventReader.EndOfStream)
                {
                    text = eventReader.ReadLine();
                    if (text.Contains("username") && text.Contains("password"))
                    {
                        userid = text.Substring(text.IndexOf("\"username\"") + 12, text.IndexOf("\",\"password") - text.IndexOf("\"username\"") - 12);
                    }
                }
                eventReader.Close();
                eventStream.Close();
                if (!UserID.Equals(userid))
                {
                    UserID = userid;
                    new Thread(() =>
                    {
                        UserInfo();
                    }).Start();
                }
            }
            catch (Exception log)
            {
                Logging(log.Message);
            }
            try
            {
                FileStream fileStream = new FileStream(filePath, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
                StreamReader streamReader = new StreamReader(fileStream);
                Cleanup();
                string line = "line";
                string[] time = new string[3];
                string errKey = "error";
                long timeStart = 0;
                long timeEnd = 0;
                int chars = 0;
                int i = 0;
                while (!streamReader.EndOfStream)
                {
                    line = streamReader.ReadLine();
                    chars = 0;
                    if (line.Length >= 8)
                    {
                        for (i = 0; i < line.Length; i++)
                        {
                            if (line[i] >= 48 && line[i] <= 58)
                            {
                                chars++;
                            }
                        }
                    }
                    if (chars >= 8)
                    {
                        time = line.Substring(0, 8).Split(':');
                        if (line.Contains("Voice play"))
                        {
                            timeStart = long.Parse(time[0]) * 3600 + long.Parse(time[1]) * 60 + long.Parse(time[2]);
                        }
                        if (!line.Contains("[END]") && !line.Contains("[None]") && line.Contains("result= 0xFF"))
                        {
                            timeEnd = long.Parse(time[0]) * 3600 + long.Parse(time[1]) * 60 + long.Parse(time[2]);
                            errKey = line.Substring(17, line.IndexOf(']') - 16);
                            AddError(int.Parse(time[0]), errKey, timeEnd - timeStart);
                        }
                        if (line.Contains("[END] result= 0x00"))
                        {
                            AddPass(int.Parse(time[0]));
                        }
                    }
                }
                SyncData();
                streamReader.Close();
                fileStream.Close();
            }
            catch (Exception error)
            {
                Logging(error.Message);
            }
            ChangeText();
        }

        private void Intializer_Tick(object sender, EventArgs e)
        {
            AutoAnalysis.Enabled = true;
            Intializer.Enabled = false;
        }
    }

    public class GetUser
    {
        public Results[] results { get; set; }
    }

    public class Results
    {
        public string Name { get; set; }
        public string Address { get; set; }
        public string Gender { get; set; }
        public string Birthday { get; set; }
    }
}
